(defproject poalses.jonathan/dialect "0.0.1"
  :description "A handcrafted dialect detector for CS major project"
  :url "https://git.ysjcs.net:8888/jonathan.poalses/major-project-handcrafted"
  :scm {:name "git"
        :url  "https://git.ysjcs.net:8888/jonathan.poalses/major-project-handcrafted.git"}
  :pom-addition (:developers
                  [:developer
                   [:id "jonathan.poalses"]
                   [:name "Jonathan Poalses"]
                   [:url "https://ysjcs.net/~jonathan.poalses/"]
                   [:roles
                    [:role "developer"]
                    [:role "maintainer"]]])
  :dependencies [[org.clojure/clojure "1.11.1"]
                 ;; DataLinguist
                 [dk.simongray/datalinguist "0.2.171"]
                 [edu.stanford.nlp/stanford-corenlp "4.4.0" :classifier "models"]
                 [edu.stanford.nlp/stanford-corenlp "4.4.0" :classifier "models-english"]
                 ;; tools.namespace
                 [org.clojure/tools.namespace "1.3.0"]
                 ;; java.data
                 [org.clojure/java.data "1.0.95"]
                 ;; Logging
                 [com.taoensso/timbre "6.1.0"]
                 [com.fzakaria/slf4j-timbre "0.3.21"]
                 ;; Profiling
                 [com.taoensso/tufte "2.4.5"]
                 ;; Lifecycle management
                 [integrant "0.8.0"]
                 [integrant/repl "0.3.2"]
                 ;; Command line parsing
                 [org.clojure/tools.cli "1.0.214"]
                 ;; SCI
                 [org.babashka/sci "0.7.39"]
                 ;; nREPL
                 [babashka/babashka.nrepl "0.0.7"]
                 [org.nrepl/incomplete "0.1.0"]
                 ;; OpenJFX
                 [org.openjfx/javafx-controls "20"]
                 [org.openjfx/javafx-base "20"]
                 [org.openjfx/javafx-graphics "20"]
                 [org.openjfx/javafx-media "20"]
                 [org.openjfx/javafx-web "20"]]

  :jvm-opts ["--enable-preview"]

  :main ^:skip-aot poalses.jonathan.dialect.main

  :target-path "target/%s"

  :plugins [[lein-localrepo "0.5.4"]
            [lein-cloverage "1.2.4"]
            [lein-codox "0.10.8"]]

  :codox {:metadata {:doc/format :markdown}
          :project {:name "Dialect Detector"
                    :description "A handcrafted dialect detector for CS major project."}}

  :cloverage {:ns-exclude-regex [#".*-debug" #".*main"]}

  :profiles {:uberjar {:aot      :all
                       :jvm-opts ["-Dclojure.compiler.direct-linking=true"]}
             :dev     {:jvm-opts ["-XX:-OmitStackTraceInFastThrow"]}
             :test    {:plugins [[lein-test-report-junit-xml "0.2.0"]]
                       :dependencies [[com.github.seancorfield/expectations "2.0.165"]]}
             :deploy  {:plugins []}}

  :repl-options {:init-ns user
                 :init (do (set! *print-length* 50)
                           (set! *print-level* 20))})

